string sInt(Int_t number)
{
    stringstream ss;//create a stringstream
    ss << number;//add number to the stream
    return ss.str();//return a string with the contents of the stream
}
bool IsEqual(double a,double b , double eps,double releps)
{
	if(a==b)
	{
		return true;
	}
	
	if(fabs(a-b)<=releps*fabs(b))
	{
		return true;
	}
	
	if(fabs(a-b)<eps)
	{
      return true;
	}
		
	return false;
}
double eps=1e-15;//absolut difference
double releps=1e-10;//relative difference

bool IsEqual1(double a,double b , double eps,double releps)
{
	
	if(fabs(a-b)<=releps*fabs(b))
	{
		return true;
	}
	
	if(fabs(a-b)<eps)
	{
      return true;
	}
		
	return false;
}
double eps1=0.1;//absolut difference
double releps1=0.1;//relative difference
  
void UncertaintyCheck_Livermore()
{
	gSystem->Exec("mkdir -p plots/MassAttenuationCoefficientTotal");
	double e; //energy 
	double cs; // cross section
    Int_t ncols = 0;
	double energies[50] = {0.001, 1.50E-03, 2.000000000E-03, 3.00E-03, 0.004, 0.005, 6.00E-03, 0.008, 0.01, 0.015,
							0.02, 0.03, 0.04, 0.05, 0.06, 0.08, 0.1, 1.50E-01, 0.2, 0.3, 
							0.4, 0.5, 0.6, 0.8, 1, 1.022, 1.25, 1.5, 2, 2.044, 
							3, 4, 5, 6, 7, 8, 9, 10, 15, 20, 
							50, 100, 500, 1000, 5000, 10000, 50000, 60000, 80000, 100000};
	string Materials[20] = {"Be", "C", "Al", "Si", "Fe", "Ge", "Ag", "Cs", "Au", "Pb", "U", "Water", "BONE_COMPACT_ICRU"};
	int MaterialsAtomicNum[20] = {4, 6, 13, 14, 26, 32, 47, 55, 79, 82, 92, 101, 102};
	
	for (int z =0; z<12;z++) // loop for materials
	{
	
		
			
		// read Livermore data begin***************************************************
		std::ostringstream ost3;
		// ost3 << "livermore_data/AttenuationCoefficient_Water_livermore.dat";
		ost3 << "livermore_data/AttenuationCoefficient_"<<Materials[z]<<"_livermore.dat";
		std::ifstream fin3(ost3.str().c_str());
		
		cout<<z<<"-------------For Livermore uncertainty check for "<<Materials[z]<<endl;
		for(int i = 0; i<50; i++)
		{
			double P[17] = {0};
			
			fin3 >> P[0] >> P[1]>> P[2] >> P[3]>>P[4] >> P[5]>> P[6]
			>> P[7] >> P[8]>> P[9] >> P[10] >> P[11]>> P[12] >> P[13]
			>>P[14] >> P[15]>> P[16];	
			
			// printf("%d %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e %.9e\n", 
					// i+1, P[0], P[1], P[2], P[3], P[4], P[5], P[6],
					// P[7], P[8], P[9], P[10], P[11], P[12], P[13],
					// P[14], P[15], P[16]);
					
			printf("%d %.9e %.9e\n", i+1, P[0], P[6]);
					
			if(P[6]>0.003 || P[6]== -1 ) // uncertainty should be low than 0.3%
			{
				printf("--------------------------------------invalid point: %.9e\n", P[0]);
			}		
			
			 
		}
			
		
		fin3.close();
	   // read Livermore data end***************************************************
	   
	   
	}
	
}	
		
	           
            	
    
   